//
//	Mouse.c
//	Team	NAHVG
//

#include "ps2_mouse.h"
#include<stdio.h>
#include "alt_up_ps2_port.h"

int m_dir_x=0; 
int m_dir_y=0; 
int prev_m_dir_x = 0;
int prev_m_dir_y = 0;
#define STATUS_ERROR 0x00
#define STATUS_ACK 0xFA
#define PRESSED  1
#define RELEASED  2

int myread()
{
	int data = 0;
	while( 1 )
   	{
        	data = read_data_reg(); 
		if( ( ( data >> 16) & 0xFFFF ) != 0 )
        	{ 
			return data;
        	} 
	}
}

void write1(int data)
{
    write_data_byte(data);
}

void init()
{
	write1( MOUSE_RESET );
	myread( );
	myread( );
	write1( MOUSE_SET_SAMPLE_RATE ); 
	myread( );
	write1( 0x28 );             //200
	myread( );
	write1( MOUSE_SET_RESOLUTION ); 
	myread( );
	write1( 0x02);         // Resolution is 4count/mm
	myread( ); 
	write1 ( 0xE7 );  // scaling 2:1
	myread( ); 
	write1( MOUSE_STREAM_MODE );
	// changed to stream mode
	myread( ); 
}  

int update1( )
{ 
	int x_sign = 0; 
	int y_sign = 0;
	int data[ 10 ] = { 0, };
	// wait for ack 
   
	//write_data_byte(0xEB);
	IOWR(ALT_UP_PS2_BASE, 0, 0xEB);
	while( (myread( ) & 0xFF) != STATUS_ACK ); 
	int loop = 3; 
	while( loop )
	{
		data[ 3 - loop ] = myread(); 
	        if( data[ 3 - loop ] == STATUS_ERROR ) 
        	{ 
			return 0; 
        	} 
        	if( ( unsigned char ) (data[ 3 - loop ] & 0xFF ) == ( unsigned char ) STATUS_ACK ) 
            	{
			loop = 3;
              	}
		else
           	{
			loop--;
             	} 
	} // set button 
           
        if( ( ((data[ 0 ] >> 4 ) & 0x01 == 1 ))) 
	{
		x_sign = 1; 
	} 
        if( ( (data[ 0 ] >>5 ) & 0x01 == 1 )) 
	{ 
		y_sign = 1; 
	} 
        
        // printf("data[0]=%d data[1]=%d data[2]=%d\n ",data[0],data[1],data[2]);
        m_dir_x = data[1] & 0xFF;
        m_dir_y = data[2] & 0xFF;
          
	if( x_sign == 0 ) 
        { 
		m_dir_x = 0 - (data[ 1 ] & 0xFF);

        }     
	else 
	{
		m_dir_x =  (~(data[ 1 ] & 0xFF) + 1 ) & 0xFF;  
        }
        
            
        if( y_sign == 0 ) 
        { 
		m_dir_y = 0 - ( data[ 2 ] & 0xFF ); 
        } 
        else 
        { 
		m_dir_y = ( ~( data[ 2 ] & 0xFF ) + 1 ) & 0xFF; 
        } // remove mouse's pop data 
       
        if ( ( m_dir_y >= 100 ) || ( m_dir_y <= -100 ) )
	{
		m_dir_y = prev_m_dir_y;
	}
        if ( ( m_dir_x >= 200 ) || ( m_dir_x <= -200 ) )
        {
		m_dir_x = prev_m_dir_x;
	}
     
        if ( ( m_dir_x == -24 ) || ( m_dir_x == -40 )  || ( m_dir_x == -8 ) )
        {
		m_dir_x = prev_m_dir_x; 
        }
        if(m_dir_x == -8)
        {
		m_dir_x = 0;
	}
        return 1; 
}
   

void capture_mouse(int *x , int *y)
{
	if (update1())        
  	{
     		//  printf("mdirx =%d\n",m_dir_x);
		*x -= (m_dir_x);
       		*y += m_dir_y;
       		if ( *x> 129)
       			*x = 129;
       		if (*y > 454)
       			*y = 454;
       		if ( *x < 10)       
       			*x = 10;
       		if (*y < 10)
       			*y = 10;
      		// printf("dir_x = %d dir_y = %d\n", *x, *y);
  	}
	else
     		init();   
}
